#
# a few useful routines.	Guy Streeter, 3/31/92
#
package SNMP;

# not much debug output here, but it can be turned on by setting
# $SNMP'debug to a positive value.

$debug = 0;

# &inet_addr takes an IP address in ASCII dotted quad form (0.0.0.0) and
# returns an integer in network byte-order.

sub main'inet_addr {			# @_ = (dotted quad)
    return unpack("N",pack("C4",split(/\./,$_[0])));
}

# &inet_ntoa takes an integer IP address in network byte-order and returns
# an ASCII string in dotted decimal notation.

sub main'inet_ntoa {			# @_ = (integer)
    return join('.',unpack('C4',pack('N',$_[0])));
}

# &dottedquad takes a hostname or dotted-quad IP address and returns
# a dotted-quad address.

sub main'dottedquad {		# @_ = (hostname or dotted quad)
    if ($_[0] =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)/) {
	return $_[0];
    } else {
	$saddr = (gethostbyname($_[0]))[4] || return undef;
	return join('.',unpack("C4",$saddr));
    }
}

# $SNMP'communityFile specifies the location of a DBM file that associates
# a host with a Community string.

$communityFile = "/etc/mib.commun";

# &communityString returns the Community string associated with a given
# key.  For simplicity the key should be the dotted-decimal ASCII form
# of the address of the host, but the routine doesn't care what the key
# is.  "public" is returned if the key or the file doesn't exist.

sub main'communityString {		# @_ = (dotted quad)
    if (undef %communityArray) {
	warn "opening $communityFile for reading\n" if $debug;
	dbmopen(%communityArray,$communityFile,undef)
	    || warn "somebody stole $communityFile!\n" if $debug;
    }
    warn "using default community\n" if $debug > 1
	&& ! $communityArray{@_[0]};
    return "$communityArray{@_[0]}" || "public";
}
